/*
TNKernel real-time kernel

Copyright  2004,2007 Yuri Tiomkin
All rights reserved.

Permission to use, copy, modify, and distribute this software in source
and binary forms and its documentation for any purpose and without fee
is hereby granted, provided that the above copyright notice appear
in all copies and that both that copyright notice and this permission
notice appear in supporting documentation.

THIS SOFTWARE IS PROVIDED BY THE YURI TIOMKIN AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL YURI TIOMKIN OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/

/* ver 2.4 */

#include "tn.h"

//----------------------------------------------------------------------------
// This functions will works for all processors where
// sizeof(void*) = sizeof(int) (include ARM7)
//----------------------------------------------------------------------------
TN_TCB * get_task_by_timer_queque(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;

   ptr = (unsigned int*)que;
   ptr --;
   ptr -= (sizeof(CDLL_QUEUE)/sizeof(void*));
   return (TN_TCB *)ptr;
}
//----------------------------------------------------------------------------
TN_TCB * get_task_by_tsk_queue(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;
   ptr = (unsigned int*)que;
   ptr --;
   return (TN_TCB *)ptr;
}
//----------------------------------------------------------------------------
TN_TCB * get_task_by_block_queque(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;

   ptr = (unsigned int*)que;
   ptr --;
   ptr -= (sizeof(CDLL_QUEUE)/sizeof(void*)) << 1;
   return (TN_TCB *)ptr;
}

//----------------------------------------------------------------------------
TN_MUTEX * get_mutex_by_mutex_queque(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;

   ptr = (unsigned int*)que;
   ptr -= (sizeof(CDLL_QUEUE)/sizeof(void*));

   return (TN_MUTEX *)ptr;
}

//----------------------------------------------------------------------------
TN_MUTEX * get_mutex_by_lock_mutex_queque(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;

   ptr = (unsigned int*)que;
   ptr -= (sizeof(CDLL_QUEUE)/sizeof(void*)) << 1; //-- * 2

   return (TN_MUTEX *)ptr;
}

//----------------------------------------------------------------------------
TN_MUTEX * get_mutex_by_wait_queque(CDLL_QUEUE * que)
{
   unsigned  int * ptr;
   if(que == NULL)
      return NULL;

   ptr = (unsigned int*)que;

   return (TN_MUTEX *)ptr;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

